package com.ssv.test.airbase.contest;

import com.ssv.utils.parser.ParserException;
import com.ssv.utils.parser.Parser.ParserContext;
import com.ssv.utils.tree.BinaryTree;

/**
 *       
 *  . 
 *  
 * @see com.ssv.test.airbase.contest.expressions
 *  
 * @author Sergey.Siryk
 */
public abstract class Expression extends BinaryTree<Expression> {

	public Expression(Expression left, Expression right,ParserContext ctx) {
		super(left,right);
		this.ctx=ctx;
	}

	/**
	 *   ,   .
	 */
	abstract public double evaluate() throws ParserException;
	
	final private ParserContext ctx;
	
	/**
	 *      . 
	 *  -  -  ,   ""
	 *    -   ,  .
	 * @return  
	 */
	public ParserContext ctx() {
		return ctx;
	}
}