package com.ssv.test.airbase.contest;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.ssv.test.airbase.contest.ui.ContestWindow;
import com.ssv.utils.parser.ParserException;

/**
 *    .<p> 
 * 
 *   , ""   ,  
 *         .
 * 
 * @author Sergey Siryk
 *
 */

public class Interpretator {

	private static Logger log = Logger.getLogger("Contest");	
	
	public static void main(String[] args) {		
		log.setLevel(Level.WARNING);
		
		boolean pause_after = false;
		String filename = null;
		
		for(String s:args) {
			if(s.equalsIgnoreCase("pause"))
				pause_after = true;
			if(s.startsWith("-f:", 0)) {
				if(s.length()>3)
					filename=s.substring(3);
			}
		}
		
		InputStream is = null;
		
		try {
			if(filename==null) {
				throw new Error("Filename is not specified.\n"+
					"Usage: Interpretator <pause> -f<filename>");
			}
			ContestParser tokens = new ContestParser();
			is = new FileInputStream(new File(filename));
			tokens.init(is);
			Operator op = tokens.compile();
			Execution exec = new Execution(op);
			exec.run();
			
			ContestWindow.shutdownWindow();
			
			if(pause_after) {
				System.out.println("\nPress any key to continue.");
				System.in.read();
			}
		} catch (ParserException e) {
			System.out.println();
			System.out.println(e.toString());
			System.out.println("\nPress any key to continue.");
			try {
				System.in.read();
			} catch (IOException e1) {
			}
		} catch (Throwable e) {
			System.out.println();
			System.out.println(e.getMessage());
			System.out.println("\nPress any key to continue.");
			try {
				System.in.read();
			} catch (IOException e1) {
			}
		} finally {
			if(is!=null)
				try {
					is.close();
				} catch (IOException e) {
				}
		}
	}

}
