package com.ssv.test.airbase.contest.expressions;

import java.util.List;

import com.ssv.test.airbase.contest.Expression;
import com.ssv.test.airbase.contest.Scope;
import com.ssv.utils.parser.ParserException;
import com.ssv.utils.parser.Parser.ParserContext;

public abstract class AssignableVariable extends Expression {
		public static Expression makeVariable(
				List<ExpressionIndexed.Part> list, 
				ParserContext ctx) {
			if(list.size()==1) {
				if((list.get(0).getClass()==ExpressionIndexed.StringPart.class)) {
					ExpressionIndexed.StringPart p = (ExpressionIndexed.StringPart)list.get(0);
					return new ExpressionVariable(p.toString(), ctx);
				} else if((list.get(0).getClass()==ExpressionIndexed.NumPart.class)) {
					ExpressionIndexed.NumPart p = (ExpressionIndexed.NumPart)list.get(0);
					return new ExpressionConstant(p.getNumber(), ctx);
				} else if((list.get(0).getClass()==ExpressionIndexed.ExpressionPart.class)) {
					ExpressionIndexed.ExpressionPart part = null;
					part = (ExpressionIndexed.ExpressionPart)(list.get(0));
					if(part.expr.getClass()==ExpressionConstant.class) {
						double d = ((ExpressionConstant)part.expr).constant;
						return new ExpressionConstant(d, ctx);
					}
				}
			}
			return new ExpressionIndexed(list, ctx);
		}
	
		public AssignableVariable(ParserContext ctx) {
			super(null,null,ctx);
		}	
		
		abstract public Scope.Variable getVariable() throws ParserException;
		
		public double evaluate() throws ParserException {
			return getVariable().getValue();
		}
		
		public void set(double value) throws ParserException {
			getVariable().setValue(value);
		}		
}
