package com.ssv.test.airbase.contest.expressions;

import java.util.ArrayList;
import java.util.List;

import com.ssv.test.airbase.contest.Expression;
import com.ssv.test.airbase.contest.Function;
import com.ssv.test.airbase.contest.Functions;
import com.ssv.utils.parser.ParserException;
import com.ssv.utils.parser.Parser.ParserContext;

public class ExpressionFunction extends Expression {

	public ExpressionFunction(String name, List<Expression> parms, ParserContext ctx) {
		super(null,null,ctx);
		this.parms = parms;
		action=Functions.getFunction(name);
	}

	final Function action;
	final List<Expression> parms;		
		
	private static final long serialVersionUID = -612301115731686413L;

	public double evaluate() throws ParserException {
		List<Double> listparm = new ArrayList<Double>();
		for(Expression prm:parms) {
			listparm.add(prm.evaluate());
		}
		return action.evaluate(listparm);
	}
}
