package com.ssv.test.airbase.contest.expressions;

import com.ssv.test.airbase.contest.Expression;
import com.ssv.test.airbase.contest.DoubleOperations;
import com.ssv.utils.parser.ParserException;
import com.ssv.utils.parser.Parser.ParserContext;
import com.ssv.utils.parser.Parser.Token;

/**
 *	This node represent ariphmetical action, like +, - etc.
 *  This is non-leaf node and it always has both left and right branches 
 *  non-null.  , ,     .
 *     ,       
 *    .
 */

public class ExpressionOperation extends Expression {
	private static final long serialVersionUID = 1350435482539419594L;

	public ExpressionOperation(Token token, Expression left, Expression right, ParserContext ctx) {
		super((left==null)?
				new ExpressionConstant(0,ctx):left,
				right,ctx);
		action=DoubleOperations.getAction(token.code());
		this.token=token;
	}	
	
	final Token token;
	final DoubleOperations.Action action;
	
	public String toString() {
		return getLeft().toString()+token.toString()+getRight().toString();
	}	

	public double evaluate() throws ParserException {
		return action.action(getLeft(), getRight()); 
	}
}
