package com.ssv.test.airbase.contest.operators;

import com.ssv.test.airbase.contest.Execution;
import com.ssv.test.airbase.contest.Operator;
import com.ssv.test.airbase.contest.Scope;
import com.ssv.test.airbase.contest.Execution.Goto;

/**
 *   :<p>
 * 
 * <code>
 * 		goto label;
 * </code>
 * 
 * @author Sergey Siryk
 */
public class GotoOperator implements Operator {
	/**
	 * @param name -    .
	 */
	public GotoOperator(String name) {
		this.name=name;
	}
	
	final private String name;

	public String getName() {
		return name;
	}
	
	public void run() {
		/*
		 *      ,
		 *     "".
		 */
		throw new Error("GotoOperator.run() is not implemented.");
	}

	public void generate(Execution execution) {
		Scope.Mark mark = Scope.getMark(getName());
		Goto gt = new Goto(getName());
		
		if(mark==null) { // This goto is not defined yet - it goes forward.
			mark = Scope.createMark(getName());
		}
		
		if(mark.getPos()==-1) {
			mark.addForward(gt); // This goto is supposed to be renewed when
								 // mark satisfied.
		} else {
			gt.setMarker(mark.getPos());
		}
		
		execution.add(gt);
	}
}
