package com.ssv.test.airbase.contest.operators;

import com.ssv.test.airbase.contest.Execution;
import com.ssv.test.airbase.contest.Expression;
import com.ssv.test.airbase.contest.Operator;
import com.ssv.test.airbase.contest.Execution.ConditionalGoto;
import com.ssv.test.airbase.contest.Execution.Goto;
import com.ssv.utils.parser.ParserException;

/**
 * ,  <p>
 * 
 * <pre><code>
 * 		while(condition) {
 * 			operator1;
 * 		} 
 * </code></pre>
 * 
 * @author Sergey Siryk
 */
public class WhileOperator extends IfOperator {
	public WhileOperator(Expression condition, Operator operator) {
		super(condition, operator);
	}

	public void run() throws ParserException {
		while(ok())
			operator.run();
	}
	
	public void generate(Execution execution) {
		ConditionalGoto cg = new ConditionalGoto(getCondition());
		int begin = execution.size();
		execution.add(cg);
		getOperator().generate(execution);
		Goto gt = new Goto(getCondition().toString());
		gt.setMarker(begin);
		execution.add(gt);
		cg.setMarker(execution.size());
	}
}
