package com.ssv.utils;

import java.io.Serializable;
import java.util.List;

public interface Stack<E> extends Iterable<E>, Serializable {
	/**
	 * Removes top element from the stack, returns is as a result.
	 */
	public E pop();
	
	/**
	 * Insert the element to the top of stack.
	 */
	public E push(E e);

	/**
	 * This method returns top of the stack without modifying it.
	 */
	public E peek();
	public int size();
	public boolean empty();
	public void clear();
	public List<E> toList();
}
