package com.ssv.utils.parser;

import java.util.Iterator;

public final class DigitSequence implements Iterable<Byte> {

	public DigitSequence() {
		numbers=new byte[0];
	}

	DigitSequence(byte bytes[]) {
		numbers=bytes;
	}	
	
	public DigitSequence(String snumbers) {
		numbers = new byte[snumbers.length()];
		
		for(int i=0;i<snumbers.length();i++) {
			numbers[i]=(byte) (Character.getNumericValue(snumbers.charAt(i)));
		}
	}
	
	public DigitSequence(DigitSequence clone) {
		numbers=new byte[clone.numbers.length];
		System.arraycopy(clone.numbers, 0, numbers, 0, numbers.length);
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		for(byte b:numbers) {
			sb.append(b);
		}
		return sb.toString();
	}
	
	public byte maxDigit() {
		byte max=0;
		for(int i=0;i<numbers.length;i++) {
			byte b = numbers[i];
			if(b>max)
				max=b;
		}
		return max;
	}
	
	public int size() {
		return numbers.length;
	}

	public int at(int index) {
		return numbers[index];
	}	
	
	final byte numbers[];
		
	private class MyIterator implements Iterator<Byte> {

		public MyIterator() {
			
		}
		
		int index = 0;
		
		public boolean hasNext() {
			return index<numbers.length;
		}

		public Byte next() {
			return numbers[index++];
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
	
	public Iterator<Byte> iterator() {
		return new MyIterator();
	}
	
	public long toLong(int B) {
		long d = 0;
		long c = 1;
		for(int i=numbers.length-1;i>=0;i--) {
			byte b = numbers[i];
			d=d+c*b;
			c*=B;
		}
		return d;
	}
	
	public static void main(String[] args) {
		DigitSequence ns=new DigitSequence("12345612");
		System.out.println(ns);
		System.out.println(new DigitSequence());
		System.out.println(new DigitSequence(ns));
		for(byte b:ns) {
			System.out.print(b+" ");
		}
	}	
}
