package com.ssv.utils.parser;

import com.ssv.utils.parser.Parser.ParserContext;

public class ParserException extends Exception {
	private static final long serialVersionUID = -6164423668990760702L;

	public ParserException(String message, ParserContext ctx) {
		this(message,ctx.getColumn(),ctx.getRow());
	}

	public ParserException(Throwable e, ParserContext ctx) {
		super("Error:", e);
		pos=ctx.getColumn();
		line=ctx.getRow();
	}
	
	public ParserException(String message, int _pos, int _line) {
		super(message);
		pos=_pos;
		line=_line;
	}
	
	public ParserException(Exception cause, String message, int _pos, int _line) {
		super(message, cause);
		pos=_pos;
		line=_line;
	}
		
	public int getLine() {
		return line;
	}

	public int getPos() {
		return pos;
	}	
	
	private String getPostfix() {
		return "[col:"+pos+", row:"+(line+1)+"]";
	}

	public String toString() {
		return getPostfix()+" "+super.toString();
	}

	private int pos,line;
}
