package com.ssv.utils.tree;

/**
 * This is default implementation of Tree.IAction. This is very basic, the
 * only addition is the control mechanism to know the level of hierarchy we
 * are at now.
 * 
 * @author Sergey Siryk
 * 
 */
public abstract class AbstractTreeAction<Leaf extends Tree<Leaf>> 
implements ITreeAction<Leaf> {
	/**
	 * @return level of hierarchy tree route method is handling now.
	 */
	final public int getLevel() {
		return hierarchyLevel;
	}

	public final void enter() {
		hierarchyLevel++;
		onEnter();
	}

	public final void exit() {
		onExit();
		hierarchyLevel--;
	}

	protected void onEnter() {
	};

	protected void onExit() {
	};

	private int hierarchyLevel = 0;
}

