package com.ssv.utils.tree;

import java.util.Iterator;

public class DefaultTreeIterator<L extends Tree<L>> 
implements Iterator<L> {
	public DefaultTreeIterator(Tree<L> _root) {
		root=_root;
	}
	
	public boolean hasNext() {
		return currentNodeIdx < root.size();
	}

	public L next() {
		return lastElement = root.getNode(currentNodeIdx++);
	}

	public void remove() {
		if (lastElement == null)
			throw new IllegalStateException();
		root.remove(lastElement);
	}

	L lastElement;
	Tree<L> root;

	private int currentNodeIdx = 0;
}
